/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/03/29 10:28:16
 */

export function animate(duration = 200, fromto = [], out = false) {
  if (out === false) {
    this.style.display = ''
  }
  let res = this.animate(fromto, {
    duration,
    direction: out ? 'reverse' : 'normal',
    fill: 'forwards'
  })
  return new Promise(resolve => {
    res.addEventListener(
      'finish',
      _ => {
        if (out) {
          this.style.display = 'none'
        }
        res.cancel()
        resolve()
      },
      { once: true }
    )
  })
}
export const MODES = {
  fade: [{ opacity: 0 }, { opacity: 1 }],
  scale: [{ transform: 'scale(0)' }, { transform: 'scale(1)' }],
  'micro-bounce': [
    { opacity: 0, transform: 'scale(0.8)' },
    { transform: 'scale(1.05)', opacity: 1 },
    { transform: 'scale(1)' }
  ],
  slide: [
    { opacity: 0, transform: 'translateY(-50px)' },
    { opacity: 1, transform: 'translateY(0)' }
  ],
  bounce: [
    { transform: 'scale(0)' },
    { transform: 'scale(1.2)' },
    { transform: 'scale(1)' }
  ],
  rotate: [{ transform: 'rotate(0)' }, { transform: 'rotate(360deg)' }]
}
